glibmm 2.66.10

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::FilterOutputStream Class Reference
Stream Classes

Filter Output Stream. More...

`#include <giomm/filteroutputstream.h>`

Inheritance diagram for Gio::FilterOutputStream:
[legend]

## Public Member Functions
| FilterOutputStream (FilterOutputStream && src) noexcept
FilterOutputStream & | operator= (FilterOutputStream && src) noexcept
| ~FilterOutputStream () noexcept override
GFilterOutputStream * | gobj ()
| Provides access to the underlying C GObject.
const GFilterOutputStream * | gobj () const
| Provides access to the underlying C GObject.
GFilterOutputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::RefPtr< OutputStream > | get_base_stream ()
| Gets the base stream for the filter stream.
Glib::RefPtr< const OutputStream > | get_base_stream () const
| Gets the base stream for the filter stream.
bool | get_close_base_stream () const
| Returns whether the base stream will be closed when stream is closed.
void | set_close_base_stream (bool close_base=true)
| Sets whether the base stream will be closed when stream is closed.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< OutputStream > > | property_base_stream () const
| The underlying base stream on which the io ops will be done.
Glib::PropertyProxy_ReadOnly< bool > | property_close_base_stream () const
| If the base stream should be closed when the filter stream is closed.
Public Member Functions inherited from Gio::OutputStream
| OutputStream (OutputStream && src) noexcept
OutputStream & | operator= (OutputStream && src) noexcept
| ~OutputStream () noexcept override
GOutputStream * | gobj ()
| Provides access to the underlying C GObject.
const GOutputStream * | gobj () const
| Provides access to the underlying C GObject.
GOutputStream * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
gssize | write (const void * buffer, gsize count, const Glib::RefPtr< Cancellable > & cancellable)
| Tries to write count bytes from buffer into the stream.
gssize | write (const void * buffer, gsize count)
| A write() convenience overload.
gssize | write (const std::string & buffer, const Glib::RefPtr< Cancellable > & cancellable)
| Tries to write count bytes from buffer into the stream.
gssize | write (const std::string & buffer)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const void * buffer, gsize count, gsize & bytes_written, const Glib::RefPtr< Cancellable > & cancellable)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const void * buffer, gsize count, gsize & bytes_written)
| A write_all() convenience overload.
bool | write_all (const std::string & buffer, gsize & bytes_written, const Glib::RefPtr< Cancellable > & cancellable)
| Tries to write count bytes from buffer into the stream.
bool | write_all (const std::string & buffer, gsize & bytes_written)
| Tries to write count bytes from buffer into the stream.
gssize | write_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes, const Glib::RefPtr< Cancellable > & cancellable)
| A wrapper function for g_output_stream_write() which takes a Bytes as input.
gssize | write_bytes (const Glib::RefPtr< const Glib::Bytes > & bytes)
| A write_bytes() convenience overload.
void | write_bytes_async (const Glib::RefPtr< const Glib::Bytes > & bytes, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of the data in bytes to the stream.
void | write_bytes_async (const Glib::RefPtr< const Glib::Bytes > & bytes, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of the data in bytes to the stream.
gssize | write_bytes_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes a stream write-from-Bytes operation.
gssize | splice (const Glib::RefPtr< InputStream > & source, const Glib::RefPtr< Cancellable > & cancellable, OutputStreamSpliceFlags flags=OUTPUT_STREAM_SPLICE_NONE)
| Splices an input stream into an output stream.
gssize | splice (const Glib::RefPtr< InputStream > & source, OutputStreamSpliceFlags flags=OUTPUT_STREAM_SPLICE_NONE)
| Splices an input stream into an output stream.
bool | flush (const Glib::RefPtr< Cancellable > & cancellable)
| Flushed any outstanding buffers in the stream.
bool | flush ()
| A flush() convenience overload.
bool | close (const Glib::RefPtr< Cancellable > & cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
| A close() convenience overload.
void | write_async (const void * buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
void | write_async (const void * buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
gssize | write_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes a stream write operation.
void | write_all_async (const void * buffer, gsize count, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
void | write_all_async (const void * buffer, gsize count, const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous write of count bytes from buffer into the stream.
bool | write_all_finish (const Glib::RefPtr< AsyncResult > & result, gsize & bytes_written)
| Finishes an asynchronous stream write operation started with g_output_stream_write_all_async().
void | splice_async (const Glib::RefPtr< InputStream > & source, const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, OutputStreamSpliceFlags flags=OUTPUT_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Splices a stream asynchronously.
void | splice_async (const Glib::RefPtr< InputStream > & source, const SlotAsyncReady & slot, OutputStreamSpliceFlags flags=OUTPUT_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Splices a stream asynchronously.
gssize | splice_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes an asynchronous stream splice operation.
void | flush_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Flushes a stream asynchronously.
void | flush_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Flushes a stream asynchronously.
bool | flush_finish (const Glib::RefPtr< AsyncResult > & result)
| Finishes flushing an output stream.
void | close_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous close of the stream, releasing resources related to it.
void | close_async (const SlotAsyncReady & slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous close of the stream, releasing resources related to it.
bool | close_finish (const Glib::RefPtr< AsyncResult > & result)
| Closes an output stream.
bool | is_closed () const
| Checks if an output stream has already been closed.
bool | is_closing () const
| Checks if an output stream is being closed.
bool | has_pending () const
| Checks if an output stream has pending actions.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void * data)
void | set_data (const Quark & key, void * data, DestroyNotify notify)
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
void | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, const sigc::slot< void > & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed_with_return (const Glib::ustring & property_name, sigc::slot< void > && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gio::OutputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| FilterOutputStream (const Glib::RefPtr< OutputStream > & base_stream)
Protected Member Functions inherited from Gio::OutputStream
| OutputStream ()
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::FilterOutputStream > | wrap (GFilterOutputStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::OutputStream
Glib::RefPtr< Gio::OutputStream > | wrap (GOutputStream * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Filter Output Stream.

This is a base class for output stream implementations that perform some kind of filtering operation on a base stream. Typical examples of filtering operations are character set conversion, compression and byte order flipping.

Since glibmm 2.16

## Constructor & Destructor Documentation

## ◆ FilterOutputStream() [1/2]

Gio::FilterOutputStream::FilterOutputStream | ( | FilterOutputStream && | src | ) |
| noexcept

## ◆ ~FilterOutputStream()

Gio::FilterOutputStream::~FilterOutputStream | ( |  | ) |
| override noexcept

## ◆ FilterOutputStream() [2/2]

Gio::FilterOutputStream::FilterOutputStream | ( | const Glib::RefPtr< OutputStream > & | base_stream | ) |
| explicit protected

## Member Function Documentation

## ◆ get_base_stream() [1/2]

Glib::RefPtr< OutputStream > Gio::FilterOutputStream::get_base_stream | ( |  | ) |

Gets the base stream for the filter stream.

Returns
  A OutputStream.

## ◆ get_base_stream() [2/2]

Glib::RefPtr< const OutputStream > Gio::FilterOutputStream::get_base_stream | ( |  | ) | const

Gets the base stream for the filter stream.

Returns
  A OutputStream.

## ◆ get_close_base_stream()

bool Gio::FilterOutputStream::get_close_base_stream | ( |  | ) | const

Returns whether the base stream will be closed when stream is closed.

Returns
  true if the base stream will be closed.

## ◆ get_type()

GType Gio::FilterOutputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GFilterOutputStream * Gio::FilterOutputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GFilterOutputStream * Gio::FilterOutputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GFilterOutputStream * Gio::FilterOutputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

FilterOutputStream & Gio::FilterOutputStream::operator= | ( | FilterOutputStream && | src | ) |
| noexcept

## ◆ property_base_stream()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr< OutputStream > > Gio::FilterOutputStream::property_base_stream | ( |  | ) | const

The underlying base stream on which the io ops will be done.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_close_base_stream()

Glib::PropertyProxy_ReadOnly< bool > Gio::FilterOutputStream::property_close_base_stream | ( |  | ) | const

If the base stream should be closed when the filter stream is closed.

Default value: true

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_close_base_stream()

void Gio::FilterOutputStream::set_close_base_stream | ( | bool | close_base = true | ) |

Sets whether the base stream will be closed when stream is closed.

Parameters

  close_base | true to close the base stream.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::FilterOutputStream > wrap | ( | GFilterOutputStream * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.